HDU 1003(最大子序列和)

来源:互联网 发布:画系统流程图的软件 编辑:程序博客网 时间:2024/05/23 18:15

Max Sum
Time Limit: 2000/1000 MS (Java/Others)
Memory Limit: 65536/32768 K (Java/Others)

Problem Description
Given a sequence a[1],a[2],a[3]……a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14.

Input
The first line of the input contains an integer T(1<=T<=20) which means the number of test cases. Then T lines follow, each line starts with a number N(1<=N<=100000), then N integers followed(all the integers are between -1000 and 1000).

Output
For each test case, you should output two lines. The first line is “Case #:”, # means the number of the test case. The second line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the first one. Output a blank line between two cases.

Sample Input
2
5 6 -1 5 4 -7
7 0 6 -1 1 -6 7 -5

Sample Output
Case 1:
14 1 4

Case 2:
7 1 6

思路:这道题也是属于动态规划的题目,要求一个序列中的最大子序列的和,稍微暴力一点的dp是求出每个位置的最大子序列和,(状态转移方程为 dp[i] = max( a[i], dp[i-1]+a[i])(其中dp[i]为第i个位置的最大子序列和),然后再去找到序列的最大子序列和与开始和结束的位置,当题目问题规模n非常大,在最坏的情况下,很容易超时(上交TLE)。因此必须进行优化。如果当前子序列的前 一 子序列和小于0,则我们可以抛弃子序列和小于0的那一部分(因为是连续的,加上一个小于的数只会使结果更小),以当前位置为当前子序列的起始位置,求出后面的子序列和。

值得注意的是题目中已经说明每个数的取值范围为-1000~1000,那么一开始初始化的最大值tmax必须比-1000小,才能将sum保存于tmax中(不然在整个序列都是负数的时候,就会出现WA)。当子序列的和大于tmax时,需要及时更新开始的位置和结束的位置以及最大值。

AC代码:

#include<stdio.h>int main(){    int T;    int n;    int temp;    int tmax;//保存最大值    int curbegin;//保存当前子序列开始的位置    int begint;//最大子序列开始位置    int endt;//最大子序列结束位置    int sum;//当前子序列的和    scanf("%d",&T);    for(int j = 1; j <= T; j++)    {        scanf("%d",&n);        //初始化        tmax = -1001;        curbegin = 1;        begint = endt = 1;        sum = 0;        for(int i = 1; i <= n; i++)        {            scanf("%d",&temp);            if(sum < 0)            {//从新的位置开始                sum = temp;                curbegin = i;            }            else            {                sum += temp;            }            if(tmax < sum)            {//状态及时更新                tmax = sum;                begint = curbegin;                endt = i;            }        }        printf("Case %d:\n",j);        printf("%d %d %d\n", tmax, begint, endt);        if(j != T)            printf("\n");    }    return 0;}
原创粉丝点击